/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.c.type;

import xcodeml.c.obj.XcNode;

/**
 * type represent 'basicType' tag.
 */
public class XcBasicType extends XcExtType
{
    public XcBasicType(String typeId)
    {
        super(XcTypeEnum.BASICTYPE, typeId);
    }

    public XcBasicType(String typeId, XcType refType)
    {
        super(XcTypeEnum.BASICTYPE, typeId);
        setRefType(refType);
    }

    @Override
    protected void resolveOverride(XcIdentTableStack itStack)
    {
    }

    @Override
    public void addChild(XcNode child)
    {
    }

    @Override
    public void checkChild()
    {
    }

    @Override
    public XcNode[] getChild()
    {
        return toNodeArray(getGccAttribute());
    }

    @Override
    public void setChild(int index, XcNode child)
    {
        throw new IllegalArgumentException(index + ":" + child.getClass().getName());
    }

    @Override
    public String toString()
    {
        StringBuilder b = new StringBuilder(128);
        b.append("[");
        commonToString(b);
        b.append(",bt=").append(XcTypeEnum.BASICTYPE);
        b.append("]");
        return b.toString();
    }
}
