/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.c.type;

/**
 * type of 'float', 'double', 'long double'
 */
public abstract class XcDecimalType extends XcNumType
{
    public XcDecimalType(XcBaseTypeEnum basicTypeEnum, String typeId)
    {
        super(basicTypeEnum, typeId);
    }
    
    public static final class Float extends XcDecimalType
    {
        public Float()
        {
            this(null);
        }
        
        public Float(String typeId)
        {
            super(XcBaseTypeEnum.FLOAT, typeId);
        }
    };

    public static final class Double extends XcDecimalType
    {
        public Double()
        {
            this(null);
        }
        
        public Double(String typeId)
        {
            super(XcBaseTypeEnum.DOUBLE, typeId);
        }
    };

    public static final class LongDouble extends XcDecimalType
    {
        public LongDouble()
        {
            this(null);
        }
        
        public LongDouble(String typeId)
        {
            super(XcBaseTypeEnum.LONGDOUBLE, typeId);
        }
    };
}
