/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.c.type;

/**
 * type of 'coarray'
 */
public final class XcXmpCoArrayType extends XcArrayLikeType
{
    public XcXmpCoArrayType(String typeId)
    {
        super(XcTypeEnum.COARRAY, typeId);
    }

    @Override
    public String toString()
    {
        StringBuilder b = new StringBuilder(128);
        b.append("[");
        commonToString(b);
        b.append("coArraySize=").append(getArraySize()).append("]");
        return b.toString();
    }

    public XcType getElementType()
    {
        XcType refType = getRefType();

        if(refType.getTypeEnum() == XcTypeEnum.COARRAY)
            return ((XcXmpCoArrayType)refType).getElementType();
        else
            return refType;
    }
}
