/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.util;

import static org.junit.Assert.*;

import org.junit.Before;
import org.junit.Test;

import xcodeml.c.obj.XmcForStatement;

public class XmObjInterfaceMatcherTest
{
    XmcForStatement forStmt;

    @Before
    public void setUp() throws Exception
    {
        forStmt = new XmcForStatement();
    }

    @Test
    public void testMatch_e1()
    {
        XmObjInterfaceMatcher m = new XmObjInterfaceMatcher((String)null);
        assertFalse(m.match(forStmt));
    }
    
    @Test
    public void testMatch_e2()
    {
        XmObjInterfaceMatcher m = new XmObjInterfaceMatcher("");
        assertFalse(m.match(forStmt));
    }

    @Test
    public void testMatch_e3()
    {
        XmObjInterfaceMatcher m = new XmObjInterfaceMatcher("Hoge");
        assertFalse(m.match(forStmt));
    }
    
    @Test
    public void testMatch_s1()
    {
        XmObjInterfaceMatcher m = 
            new XmObjInterfaceMatcher("xcodeml.util.XmNode");
        assertTrue(m.match(forStmt));
    }
    
    @Test
    public void testMatch_s2()
    {
        XmObjInterfaceMatcher m = 
            new XmObjInterfaceMatcher("xcodeml.c.binding.gen.IXbcStatementsChoice");
        assertTrue(m.match(forStmt));
    }

    @Test
    public void testMatch_s3()
    {
        XmObjInterfaceMatcher m = 
            new XmObjInterfaceMatcher("java.lang.Cloneable");
        assertTrue(m.match(forStmt));
    }
    
    @Test
    public void testMatch_f1()
    {
        XmObjInterfaceMatcher m = 
            new XmObjInterfaceMatcher("xcodeml.util.XmNode");
        assertFalse(m.match(null));
    }

    @Test
    public void testMatch_f2()
    {
        XmObjInterfaceMatcher m = 
            new XmObjInterfaceMatcher("java.lang.Runnable");
        assertFalse(m.match(forStmt));
    }
    
    @Test
    public void testMatch_f3()
    {
        XmObjInterfaceMatcher m = 
            new XmObjInterfaceMatcher("xcodeml.c.obj.XmcForStatement");
        assertFalse(m.match(forStmt));
    }

}
