/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.f.decompile;

/**
 * Symbol expression in decompiler.
 */
class XfSymbol
{
    private String _symbolName;
    private XfType _typeId;
    private String _derivedName;

    public XfSymbol(String symbolName)
    {
        this(symbolName, XfType.VOID, null);
    }

    public XfSymbol(String symbolName, XfType typeId)
    {
        this(symbolName, typeId, null);
    }

    public XfSymbol(String symbolName, XfType typeId, String derivedName)
    {
        _symbolName = symbolName;
        _typeId = typeId;
        _derivedName = derivedName;
    }

    public XfType getTypeId()
    {
        return _typeId;
    }

    public String getSymbolName()
    {
        return _symbolName;
    }

    public String getDerivedName()
    {
        return _derivedName;
    }
}
