/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml;

/**
 * The tree interface for XcodeML binding object.
 * Implementing this interface allows an object the tree operation.
 */
public interface XmNode extends Iterable<XmNode>
{
    /**
     * Gets children of the node.
     *
     * @return children of the node.
     */
    public XmNode[] getChildren();

    /**
     * Sets parent of the node.
     *
     * @param n parent of the node.
     */
    public void setParent(XmNode n);


    /**
     * Gets parent of the node.
     *
     * @return parent of the node.
     */
    public XmNode getParent();
}
