/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package xcodeml.util;

import xcodeml.IXobject;
import xcodeml.XmException;
import xcodeml.XmObj;

/**
 * Represents XmObj to Xobject translator
 */
public interface XmXmObjToXobjectTranslator
{
    /**
     * Translate XmObj to Xobject/XobjectFile.
     * 
     * @param xmobj
     *      target XcodeML object
     * @return
     *      if translation is successed, translated Xobject/XobjectFile.
     *      otherwise null.
     * @throws XmException
     *      XcodeML syntax error or other error
     */
    public IXobject translate(XmObj xmobj) throws XmException;
}
