/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.block;

import exc.object.*;

/**
 * Represents for statement in C, do statement in Fortran.
 */
public interface ForBlock
{
    /** canonicalize loop expressions */
    public void Canonicalize();
    /** whether or not canonicalized */
    public boolean isCanonical();
    /** get induction variable */
    public Xobject getInductionVar();
    /** get lower bound */
    public Xobject getLowerBound();
    /** set lower bound */
    public void setLowerBound(Xobject x);
    /** get upper bound */
    public Xobject getUpperBound();
    /** set upper bound */
    public void setUpperBound(Xobject x);
    /** get step */
    public Xobject getStep();
    /** set step */
    public void setStep(Xobject x);
    /** get initialization block */
    public BasicBlock getInitBBlock();
    /** get opcode of condition expression */
    public Xcode getCheckOpcode();
    /** get body */
    public BlockList getBody();
    /** translate to Xobject */
    public Xobject toXobject();
}
