/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.block;

import exc.object.*;

//
// Simple Block, which has only basic block
//
public class SimpleBlock extends Block
{

    public SimpleBlock(Xcode code, BasicBlock bblock)
    {
        super(code, bblock);
    }

    public SimpleBlock(Xcode code)
    {
        this(code, new BasicBlock());
    }

    public SimpleBlock(SimpleBlock b)
    {
        super(b);
    }

    @Override
    public Xobject toXobject()
    {
        Xobject x = new XobjList(code, bblock.toXobject());
        x.setLineNo(getLineNo());
        return x;
    }

    @Override
    public String toString()
    {
        StringBuilder s = new StringBuilder(256);
        s.append("(SimpleBlock ");
        s.append(Opcode());
        s.append(" ");
        s.append(getBasicBlock());
        s.append(")");
        return s.toString();
    }
}
