/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

/**
 * Represents C pointer type.
 */
public class PointerType extends Xtype
{
    Xtype ref;

    public PointerType(String id, Xtype ref, int typeQualFlags, Xobject gccAttrs)
    {
        super(Xtype.POINTER, id, typeQualFlags, gccAttrs);
        this.ref = ref;
    }

    public PointerType(Xtype ref)
    {
        super(Xtype.POINTER);
        this.ref = ref;
    }

    @Override
    public Xtype getRef()
    {
        return ref;
    }

    @Override
    public Xtype copy(String id)
    {
        return new PointerType(id, ref, getTypeQualFlags(), getGccAttributes());
    }
}
