/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

/**
 * pragma syntax code.
 */
public enum PragmaSyntax
{
    SYN_NONE,
    SYN_DECL,       // declaration pragma
    SYN_EXEC,       // execution pragma
    SYN_SECTION,    // prefix of section
    SYN_PREFIX,     // prefix of block
    SYN_POSTFIX,    // end block
    SYN_START,      // start block
    ;
    
    public static PragmaSyntax valueOrNullOf(String key)
    {
        try {
            return valueOf(key);
        } catch(IllegalArgumentException e) {
            return null;
        }
    }
}
