/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

/**
 * Represents variable scope.
 */
public enum VarScope
{
    GLOBAL,
    LOCAL,
    PARAM,
    ;
    
    public String toXcodeString()
    {
        return toString();
    }
    
    @Override
    public String toString()
    {
        return super.toString().toLowerCase();
    }
    
    public static VarScope get(String scope)
    {
        for(VarScope v : values()) {
            if(v.toString().equalsIgnoreCase(scope))
                return v;
        }
        return null;
    }
}
