/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

/**
 * represents Fortran Logical Constant.
 */
public class XobjBool extends XobjConst
{
    private boolean value;
    
    public XobjBool(Xcode code, Xtype type, boolean value, String fkind)
    {
        super(code, type, fkind);
        this.value = value;
    }
    
    public XobjBool(boolean value)
    {
        this(Xcode.F_LOGICAL_CONSTATNT, null, value, null);
    }
    
    public boolean getBoolValue()
    {
        return value;
    }

    @Override
    public Xobject copy()
    {
        return copyTo(new XobjBool(code, type, value, getFkind()));
    }

    @Override
    public String toString()
    {
        return "(" + OpcodeName() + " " + value + ")";
    }
}
