/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

public class XobjInt extends XobjConst
{
    int value;

    public XobjInt(Xcode code, Xtype type, int value, String fkind)
    {
        super(code, type, fkind);
        this.value = value;
    }

    public XobjInt(Xcode code, int value)
    {
        this(code, Xtype.intType, value, null);
    }

    @Override
    public int getInt()
    {
        return value;
    }

    @Override
    public Xobject copy()
    {
        return copyTo(new XobjInt(code, type, value, getFkind()));
    }

    @Override
    public boolean equals(Xobject x)
    {
        return super.equals(x) && value == x.getInt();
    }

    @Override
    public String getName()
    {
        if(code == Xcode.REG)
            return "r_" + Long.toHexString(value);
        else
            return Long.toString(value);
    }
    
    @Override
    public String toString()
    {
        return "(" + OpcodeName() + " 0x" + Long.toHexString(value) + ")";
    }
}
