/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

import java.util.Iterator;
import java.util.NoSuchElementException;

/**
 * Iterator for XobjList
 */
public class XobjListIterator implements Iterator<Xobject>
{
    private XobjArgs _current;
    
    XobjListIterator(XobjList xobjList)
    {
        _current = xobjList.getArgs();
    }
    
    @Override
    public boolean hasNext()
    {
        return _current != null;
    }

    @Override
    public Xobject next()
    {
        if(_current == null)
            throw new NoSuchElementException();
        
        Xobject obj = _current.getArg();
        _current = _current.next;
        
        return obj;
    }

    @Override
    public void remove()
    {
        throw new UnsupportedOperationException();
    }
}
