/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
package exc.object;

import java.util.LinkedList;

public class topdownXobjectDefIterator
{
    private LinkedList<XobjectDef> defQueue = new LinkedList<XobjectDef>();
    private XobjectDef curDef;
    
    public topdownXobjectDefIterator(XobjectDef def)
    {
        defQueue.add(def);
    }
    
    public topdownXobjectDefIterator(XobjectDefEnv env)
    {
        for(XobjectDef def : env) {
            defQueue.add(def);
        }
    }
    
    public void init()
    {
        next();
    }
    
    public void next()
    {
        if(defQueue.isEmpty()) {
            curDef = null;
            return;
        }
        curDef = defQueue.removeFirst();
        
        if(curDef.hasChildren()) {
            for(XobjectDef def : curDef.getChildren())
                defQueue.add(def);
        }
    }
    
    public XobjectDef getDef()
    {
        return curDef;
    }
    
    public boolean end()
    {
        return curDef == null && defQueue.isEmpty();
    }
}
