/*
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */

package exc.xcalablemp;

import exc.object.*;
import java.util.Vector;

public class XMPobject {
  public final static int NODES		= 100;
  public final static int TEMPLATE	= 101;

  private int			_kind;
  private String		_name;
  private int			_dim;
  private Ident			_descId;
  private Vector<Xobject>	_upperVector;

  public XMPobject(int kind, String name, int dim, Ident descId) {
    _kind = kind;
    _name = name;
    _dim = dim;
    _descId = descId;
    _upperVector = new Vector<Xobject>();
  }

  public int getKind() {
    return _kind;
  }

  public String getName() {
    return _name;
  }

  public int getDim() {
    return _dim;
  }

  public Ident getDescId() {
    return _descId;
  }

  public void addUpper(Xobject upper) {
    _upperVector.add(upper);
  }

  public Xobject getUpperAt(int index) {
    return _upperVector.get(index);
  }
}
