/*
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */

#ifndef _XCALABLEMP_MATH_FUNCTION
#define _XCALABLEMP_MATH_FUNCTION

// --- integer functions
// calculate ceil(a/b)
#define _XCALABLEMP_M_CEILi(a_, b_) (((a_) % (b_)) == 0 ? ((a_) / (b_)) : ((a_) / (b_)) + 1)
// calculate floor(a/b)
#define _XCALABLEMP_M_FLOORi(a_, b_) ((a_) / (b_))
#define _XCALABLEMP_M_COUNTi(a_, b_) ((b_) - (a_) + 1)
#define _XCALABLEMP_M_COUNT_TRIPLETi(l_, u_, s_) (_XCALABLEMP_M_FLOORi(((u_) - (l_)), s_) + 1)

// --- generic functions
#define _XCALABLEMP_M_MAX(a_, b_) ((a_) > (b_) ? (a_) : (b_))
#define _XCALABLEMP_M_MIN(a_, b_) ((a_) > (b_) ? (b_) : (a_))

// defined in xmp_math_function.c
extern int _XCALABLEMP_modi_ll_i(long long value, int cycle);
extern int _XCALABLEMP_modi_i_i(int value, int cycle);

#endif //_XCALABLEMP_MATH_FUNCTION
