static char rcsid[] = "$Id$";
/* 
 * $TSUKUBA_Release: Omni XcalableMP Compiler Software Version 0.5 (alpha) $
 * $TSUKUBA_Copyright:
 *  Copyright (C) 2010 University of Tsukuba
 *  
 *  This software is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License version
 *  2.1 published by the Free Software Foundation.
 *  
 *  Please check the Copyright and License information in the file named
 *  COPYRIGHT in the top directory of the Omni Compiler Software release kit.
 *  $
 */
/* threadprivate 004 :
 * extern ѿФ threadprivate Υƥ
 */

#include <omp.h>
#include "omni.h"


int	errors = 0;
int	thds;

extern int	ext_i;
extern double	ext_d;
#pragma omp threadprivate (ext_i, ext_d)


void
func ()
{
  int	id = omp_get_thread_num ();

  ext_i = id;
  ext_d = id;
  #pragma omp barrier

  if (ext_i != id) {
    #pragma omp critical
    errors += 1;
  }

  if (ext_d != id) {
    #pragma omp critical
    errors += 1;
  }
}


main ()
{

  thds = omp_get_max_threads ();
  if (thds == 1) {
    printf ("should be run this program on multi threads.\n");
    exit (0);
  }
  omp_set_dynamic (0);

  #pragma omp parallel
  {
    int	id = omp_get_thread_num ();

    ext_i = id;
    ext_d = id;
    #pragma omp barrier

    if (ext_i != id) {
      #pragma omp critical
      errors += 1;
    }

    if (ext_d != id) {
      #pragma omp critical
      errors += 1;
    }
  }

  #pragma omp parallel 
  func ();

  func ();


  if (errors == 0) {
    printf ("threadprivate 004 : SUCCESS\n");
    return 0;
  } else {
    printf ("threadprivate 004 : FAILED\n");
    return 1;
  }
}
